<project name="HttpClient" default="compile" basedir=".">
<!--
        "HttpClient" component of the Jakarta Commons Subproject
        $Id$
        author: Remy Maucherat ( mailto:remm@apache.org )
        author: Rod Waldhoff  ( mailto:rwaldhoff@apache.org )
        author: Vincent Massol ( mailto:vmassol@apache.org )
        author: dIon Gillard  ( mailto:trongus@yahoo.com )
        author: Mark Paquette ( mailto:mpaquett@covansys.com )
        author: Jeff Dever ( mailto:jsdever@apache.org )
        author: Oleg Kalnichevski ( mailto:oleg@ural.ru )
-->

<!-- ========== Properties: Property Files  =============================== -->

  <property file="${basedir}/build.properties"/>     <!-- Component local   -->
  <property file="${basedir}/../build.properties"/>  <!-- Commons local     -->
  <property file="${user.home}/build.properties"/>   <!-- User local        -->

<!-- ========== Properties: External Dependencies ========================= -->

  <property name="lib.dir" value="./lib"/>

  <property name="commons-logging.jar" value="${lib.dir}/commons-logging.jar"/>
  <property name="commons-codec.jar" value="${lib.dir}/commons-codec.jar"/>

<!-- ========== Properties: Javadoc Properties    ========================= -->

  <property name="javadoc.j2sdk.link" value="http://java.sun.com/products/jdk/1.2/docs/api/"/>
  <property name="javadoc.logging.link" value="http://jakarta.apache.org/commons/logging/apidocs/"/>

<!-- ========== Properties: Component Declarations ======================== -->

  <!-- The name of this component -->
  <property name="component.name"          value="httpclient"/>

  <!-- The title of this component -->
  <property name="component.title"         value="HttpClient Library"/>

  <!-- The current version number of this component -->
  <property name="component.version"       value="3.1-beta1"/>

<!-- ========== Properties: Source Directories ============================ -->

  <!-- The base directory for component configuration files -->
  <property name="conf.home"               value="src/conf"/>

  <!-- The base directory for component sources -->
  <property name="source.home"             value="src"/>

  <!-- The base directory for documenation -->
  <property name="docs.home"               value="docs"/>

<!-- ========== Properties: Test Configuration ============================ -->

  <!-- The base directory for unit test sources -->
  <property name="test.home"               value="src/test"/>

  <!-- The Junit test jarfile -->
  <property name="junit.jar" value="${lib.dir}/junit.jar"/>

  <!-- The commons-logging friendly logger class to use for tests -->
  <property name="httpclient.test.log" value="org.apache.commons.logging.impl.SimpleLog"/>
  <property name="httpclient.test.loglevel" value="warn"/>
  <property name="httpclient.test.wire.loglevel" value="warn"/>

<!-- ========== Properties: Destination Directories ======================= -->

  <!-- The base directory for compilation targets -->
  <property name="build.home"              value="target"/>

  <!-- The base directory for distribution targets -->
  <property name="dist.home"               value="dist"/>

<!-- ========== Compiler Defaults ========================================= -->

  <!-- Should Java compilations set the 'debug' compiler option? -->
  <property name="compile.debug"           value="false"/>

  <!-- Should Java compilations set the 'deprecation' compiler option? -->
  <property name="compile.deprecation"     value="true"/>

  <!-- Should Java compilations set the 'optimize' compiler option? -->
  <property name="compile.optimize"        value="true"/>

  <!-- Construct compile classpath -->
  <path id="compile.classpath">
    <pathelement location="${build.home}/classes"/>
    <pathelement location="${commons-logging.jar}"/>
    <pathelement location="${commons-codec.jar}"/>
  </path>

<!-- ========== Test Execution Defaults =================================== -->

  <!-- Construct unit test classpath -->
  <path id="test.classpath">
    <pathelement location="${build.home}/classes"/>
    <pathelement location="${build.home}/tests"/>
    <pathelement location="${junit.jar}"/>
    <pathelement location="${commons-logging.jar}"/>
    <pathelement location="${commons-codec.jar}"/>
    <pathelement location="${conf.home}"/>
  </path>

  <!-- Should all tests fail if one does? -->
  <property name="test.failonerror"    value="true"/>

  <!-- The root test to execute -->
  <property name="test.runner"         value="junit.textui.TestRunner"/>
  <property name="test.entry"          value="org.apache.commons.httpclient.TestAll"/>

<!-- ========== Targets =================================================== -->

<!-- ========== Targets: "Internal" Targets =============================== -->

  <target name="init"
          description="Initialize and evaluate conditionals">
    <echo message="-------- ${component.title} ${component.version} --------"/>
    <filter token="name"    value="${component.name}"/>
    <filter token="version" value="${component.version}"/>
  </target>

  <target name="prepare" depends="init"
          description="Prepare build directory">
    <mkdir dir="${build.home}"/>
    <mkdir dir="${build.home}/classes"/>
    <mkdir dir="${build.home}/conf"/>
    <mkdir dir="${build.home}/docs"/>
    <mkdir dir="${build.home}/docs/api"/>
    <mkdir dir="${build.home}/tests"/>
    <mkdir dir="${build.home}/examples"/>
  </target>

  <target name="static" depends="prepare"
          description="Copy static files to build directory">
    <tstamp/>
    <copy todir="${build.home}/conf" filtering="on">
      <fileset dir="${conf.home}" includes="*.MF"/>
      <fileset dir="${conf.home}" includes="*.properties"/>
    </copy>
  </target>

<!-- ========== Targets: "External" Targets =============================== -->

  <target name="dist" depends="compile,doc"
          description="Create binary distribution">
    <mkdir dir="${dist.home}"/>
    <copy file="LICENSE.txt" todir="${dist.home}"/> 
    <copy file="build.xml" todir="${dist.home}"/>
    <copy file="build.properties.sample" todir="${dist.home}"/>
    <copy file="README.txt" todir="${dist.home}"/>
    <jar jarfile  ="${dist.home}/commons-${component.name}.jar"
         basedir  ="${build.home}/classes"
         manifest ="${build.home}/conf/MANIFEST.MF">
      <metainf dir="${dist.home}">
        <include name="LICENSE.txt"/>
      </metainf>
    </jar>
    <mkdir dir="${dist.home}/src"/>
    <copy todir="${dist.home}/src" filtering="on">
      <fileset dir="${source.home}"/>
    </copy>
  </target>

<!-- ========== Targets: "External" Targets: Clean-up ===================== -->

  <target name="clean"
          description="Clean build and distribution directories">
    <delete dir="${build.home}"/>
    <delete dir="${dist.home}"/>
  </target>

  <target name="all" depends="clean,compile"
          description="Clean and compile all components"/>

<!-- ========== Targets: "External" Targets: Compilation ================== -->

  <target name="compile" depends="static"
          description="Compile shareable components">
    <javac srcdir      ="${source.home}/java"
           destdir     ="${build.home}/classes"
           debug       ="${compile.debug}"
           deprecation ="${compile.deprecation}"
           optimize    ="${compile.optimize}">
      <classpath refid="compile.classpath"/>
    </javac>
    <javac srcdir      ="${source.home}/examples"
           destdir     ="${build.home}/examples"
           debug       ="${compile.debug}"
           deprecation ="${compile.deprecation}"
           optimize    ="${compile.optimize}">
      <classpath refid="compile.classpath"/>
    </javac>
  </target>

  <target name="compile.tests" depends="compile"
          description="Compile unit test cases">
    <javac srcdir      ="${test.home}"
           destdir     ="${build.home}/tests"
           debug       ="${compile.debug}"
           deprecation ="${compile.deprecation}"
           optimize    ="${compile.optimize}">
      <classpath refid="test.classpath"/>
    </javac>
    <copy todir="${build.home}/tests" filtering="on">
      <fileset dir="${test.home}" includes="**/*.properties" />
    </copy>
    <copy todir="${build.home}/tests" filtering="off">
      <fileset dir="${test.home}" includes="**/*.keystore" />
    </copy>
  </target>

<!-- ========== Targets: "External" Targets: Testing ====================== -->

  <target name="test" depends="compile.tests" if="test.entry"
          description="Run all unit test cases">
      <java classname="${test.runner}" fork="yes" failonerror="${test.failonerror}">
        <jvmarg value="-Dorg.apache.commons.logging.Log=${httpclient.test.log}"/>
        <jvmarg value="-Dorg.apache.commons.logging.simplelog.log.org.apache.commons.httpclient=${httpclient.test.loglevel}"/>
      	<jvmarg value="-Dorg.apache.commons.logging.simplelog.log.httpclient.wire=${httpclient.test.wire.loglevel}"/>
        <arg value="${test.entry}"/>
        <classpath refid="test.classpath"/>
      </java>
  </target>

<!-- ========== Targets: "External" Targets: Documenation ================= -->

  <target name="doc" depends="javadoc"
          description="Create component documentation.">
    <mkdir dir="${dist.home}"/>
    <mkdir dir="${dist.home}/docs"/>
    <copy todir="${dist.home}/docs" filtering="off">
      <fileset dir="docs"/>
    </copy>
  </target>

  <target name="javadoc" depends="compile"
          description="Create component Javadoc documentation">
    <mkdir dir="${dist.home}"/>
    <mkdir dir="${dist.home}/docs"/>
    <mkdir dir="${dist.home}/docs/api"/>
    <javadoc sourcepath   ="${source.home}/java"
             destdir      ="${dist.home}/docs/api"
             packagenames ="org.apache.commons.*"
             author       ="true"
             protected    ="true"
             version      ="true"
             doctitle     ="&lt;h1&gt;${component.title}&lt;/h1&gt;"
             windowtitle  ="${component.title} (Version ${component.version})"
             bottom       ="Copyright (c) 1999-2005 - Apache Software Foundation"
    >
      <classpath refid="test.classpath"/>
      <link href="${javadoc.j2sdk.link}"/>
      <link href="${javadoc.logging.link}"/>
    </javadoc>
  </target>

</project>
